
/* USB descriptor constants */
#define USBDESCR_DEVICE         1
#define USBDESCR_CONFIG         2
#define USBDESCR_STRING         3
#define USBDESCR_INTERFACE      4
#define USBDESCR_ENDPOINT       5
#define USBDESCR_HID            0x21
#define USBDESCR_HID_REPORT     0x22
#define USBDESCR_HID_PHYS       0x23

#define USBATTR_BUSPOWER        0x80
#define USBATTR_SELFPOWER       0x40
#define USBATTR_REMOTEWAKE      0x20

/* USB HID Requests */
#define USBRQ_HID_GET_REPORT    0x01
#define USBRQ_HID_GET_IDLE      0x02
#define USBRQ_HID_GET_PROTOCOL  0x03
#define USBRQ_HID_SET_REPORT    0x09
#define USBRQ_HID_SET_IDLE      0x0a
#define USBRQ_HID_SET_PROTOCOL  0x0b

extern PROGMEM char usbDescrDevice[];
extern PROGMEM char usbDescrConfig[];
extern PROGMEM char  usbDescrString0[];
extern PROGMEM int16_t  usbDescrString1[];
extern PROGMEM int16_t  usbDescrString2[];
extern PROGMEM int16_t  usbDescrString3[];


#if 0
#define EP_RX		 1
#define EP_TX		 2
#define EP_INT		 3
#else
#define EP_RX		 3
#define EP_TX		 4
#define EP_INT		 1
#endif

#define USE_DUAL_BANK_BULK	1
#define EP_SIZE		 8
#define EP_TX_SIZE	32
#define EP_RX_SIZE	32
#define EP_INT_SIZE	 8

#define USB_CFG_IS_SELF_POWERED         0
/* Define this to 1 if the device has its own power supply. Set it to 0 if the
 * device is powered from the USB bus.
 */
